
/*****************************************************************************
                         E R I N A - L i b r a r y
                                                      ŏIXV 2001/05/23
 ----------------------------------------------------------------------------
         Copyright (C) 2000-2001 Leshade Entis. All rights reserved.
 *****************************************************************************/


#if	!defined(EXPERI_H_INCLUDED)
#define	EXPERI_H_INCLUDED


/*****************************************************************************
                       CuEI֐
 *****************************************************************************/

#if	defined(_M_IX86) && !defined(ERI_INTEL_X86)
#define	ERI_INTEL_X86
#endif

extern	"C"
{
	void eriInitializeLibrary( void ) ;
	void eriCloseLibrary( void ) ;
	void eriInitializeTask( void ) ;
	void eriCloseTask( void ) ;
#if	defined(ERI_INTEL_X86)
	void eriEnableMMX( int fForceEnable = 0 ) ;
	void eriDisableMMX( int fForceDisable = 0 ) ;
	void eriInitializeFPU( void ) ;
#endif

} ;

#if	defined(ERI_INTEL_X86)
#define	ERI_USE_MMX_PENTIUM	0x0002
#define	ERI_USE_XMM_P3		0x0008
extern	"C"	DWORD	ERI_EnabledProcessorType ;
#endif


/*****************************************************************************
                         AP[V
 *****************************************************************************/

extern	PVOID eriAllocateMemory( DWORD dwBytes ) ;
extern	void eriFreeMemory( PVOID ptrMem ) ;


/*****************************************************************************
                                摜
 *****************************************************************************/

struct	ERI_FILE_HEADER
{
	DWORD	dwVersion ;
	DWORD	dwContainedFlag ;
	DWORD	dwKeyFrameCount ;
	DWORD	dwFrameCount ;
	DWORD	dwAllFrameTime ;
} ;

struct	ERI_INFO_HEADER
{
	DWORD	dwVersion ;
	DWORD	fdwTransformation ;
	DWORD	dwArchitecture ;
	DWORD	fdwFormatType ;
	SDWORD	nImageWidth ;
	SDWORD	nImageHeight ;
	DWORD	dwBitsPerPixel ;
	DWORD	dwClippedPixel ;
	DWORD	dwSamplingFlags ;
	SDWORD	dwQuantumizedBits[2] ;
	DWORD	dwAllottedBits[2] ;
	DWORD	dwBlockingDegree ;
	DWORD	dwLappedBlock ;
	DWORD	dwFrameTransform ;
	DWORD	dwFrameDegree ;
} ;

struct	RASTER_IMAGE_INFO
{
	DWORD	fdwFormatType ;
	PBYTE	ptrImageArray ;
	SDWORD	nImageWidth ;
	SDWORD	nImageHeight ;
	DWORD	dwBitsPerPixel ;
	SDWORD	BytesPerLine ;
} ;

#if	!defined(__ENTISGLS_H__)
union	ENTIS_PALETTE
{
	struct
	{
		BYTE	Blue ;
		BYTE	Green ;
		BYTE	Red ;
		BYTE	Reserved ;
	}			rgb ;
	struct
	{
		BYTE	Blue ;
		BYTE	Green ;
		BYTE	Red ;
		BYTE	Alpha ;
	}			rgba ;
} ;
#endif

#define	EFH_CONTAIN_IMAGE		0x00000001
#define	EFH_CONTAIN_ALPHA		0x00000002
#define	EFH_CONTAIN_PALETTE		0x00000010
#define	EFH_CONTAIN_WAVE		0x00000100
#define	EFH_CONTAIN_SEQUENCE	0x00000200

#define	ERI_RGB_IMAGE			0x00000001
#define	ERI_RGBA_IMAGE			0x04000001
#define	ERI_GRAY_IMAGE			0x00000002
#define	ERI_TYPE_MASK			0x00FFFFFF
#define	ERI_WITH_PALETTE		0x01000000
#define	ERI_USE_CLIPPING		0x02000000
#define	ERI_WITH_ALPHA			0x04000000

#define	CVTYPE_LOSSLESS_ERI		0x03020000
#define	CVTYPE_DCT_ERI			0x00000001
#define	CVTYPE_LOT_ERI			0x00000005

#define	ERI_ARITHMETIC_CODE		32
#define	ERI_RUNLENGTH_GAMMA		0xFFFFFFFF
#define	ERI_RUNLENGTH_HUFFMAN	0xFFFFFFFC

#define	ERISF_YUV_4_4_4			0x00040404
#define	ERISF_YUV_4_2_2			0x00040202
#define	ERISF_YUV_4_1_1			0x00040101



/*****************************************************************************
                            Aj[Vp֐
 *****************************************************************************/

extern	"C"
{
	int eriAdditionOfFrame
		( const RASTER_IMAGE_INFO & riiDst,
			const RASTER_IMAGE_INFO & riiSrc ) ;
	int eriSubtractionOfFrame
		( const RASTER_IMAGE_INFO & riiDst,
			const RASTER_IMAGE_INFO & riiSrc ) ;
	int eriCopyImage
		( const RASTER_IMAGE_INFO & riiDst,
			const RASTER_IMAGE_INFO & riiSrc ) ;

} ;


/*****************************************************************************
                                 `֐
 *****************************************************************************/

extern	"C"
{
	void eriDrawImageToDC
		( HDC hDC, int x, int y, const RASTER_IMAGE_INFO & rii,
			const ENTIS_PALETTE * ppalette = NULL, SIZE * psize = NULL ) ;

} ;


/*****************************************************************************
                             t@CIuWFNg
 *****************************************************************************/

class	EFileObject
{
public:
	// \z֐
	EFileObject( void ) ;
	// Ŋ֐
	virtual ~EFileObject( void ) ;
	// f[^ǂݍ
	virtual DWORD Read( void * ptrBuf, DWORD dwByte ) = 0 ;
	// t@C̒擾
	virtual DWORD GetLength( void ) = 0 ;
	// t@C|C^擾
	virtual DWORD GetPointer( void ) = 0 ;
	// t@C|C^ړ
	virtual void Seek( DWORD dwPointer ) = 0 ;

} ;

class	EReadFile	: public	EFileObject
{
protected:
	HANDLE	m_hFile ;
	bool	m_flagToClose ;

public:
	EReadFile( void ) ;
	EReadFile( HANDLE hFile ) ;
	virtual ~EReadFile( void ) ;

	bool Open( const char * pszFile ) ;
	void Attach( HANDLE hFile ) ;
	void Close( void ) ;

	virtual DWORD Read( void * ptrBuf, DWORD dwByte ) ;
	virtual DWORD GetLength( void ) ;
	virtual DWORD GetPointer( void ) ;
	virtual void Seek( DWORD dwPointer ) ;

} ;

class	EMemFile	: public	EFileObject
{
protected:
	const BYTE *	m_ptrMemory ;
	DWORD			m_dwLength ;
	DWORD			m_dwPointer ;

public:
	EMemFile( const BYTE * ptrMem, DWORD dwLength ) ;
	virtual ~EMemFile( void ) ;
	virtual DWORD Read( void * ptrBuf, DWORD dwByte ) ;
	virtual DWORD GetLength( void ) ;
	virtual DWORD GetPointer( void ) ;
	virtual void Seek( DWORD dwPointer ) ;

} ;


/*****************************************************************************
                         nt}Ec[E\
 *****************************************************************************/

#define	ERINA_CODE_FLAG			0x80000000U
#define	ERINA_HUFFMAN_ESCAPE	0x7FFFFFFF
#define	ERINA_HUFFMAN_NULL		0x8000U
#define	ERINA_HUFFMAN_MAX		0x4000
#define	ERINA_HUFFMAN_ROOT		0x200

struct	ERINA_HUFFMAN_NODE
{
	WORD	m_weight ;
	WORD	m_parent ;
	DWORD	m_child_code ;
} ;

struct	ERINA_HUFFMAN_TREE
{
	ERINA_HUFFMAN_NODE	m_hnTree[0x201] ;
	int					m_iSymLookup[0x100] ;
	int					m_iEscape ;
	int					m_iTreePointer ;

	// c[̏
	void Initialize( void ) ;
	// pxCNg
	void IncreaseOccuedCount( int iEntry ) ;
	// ȅd݂ČvZ
	void RecountOccuredCount( int iParent ) ;
	// c[̐K
	void Normalize( int iEntry ) ;
	// Vt[Gg쐬Ēǉ
	void AddNewEntry( int nNewCode ) ;
	// eo21ɂĖ؂č\
	void HalfAndRebuild( void ) ;

} ;


/*****************************************************************************
                     OXEK}EReLXg
 *****************************************************************************/

class	RLHDecodeContext
{
protected:
	int		m_flgZero ;			// [tO
	ULONG	m_nLength ;			// OX
	int		m_nIntBufCount ;	// ԓ̓obt@ɒ~ςĂrbg
	DWORD	m_dwIntBuffer ;		// ԓ̓obt@
	ULONG	m_nBufferingSize ;	// obt@OoCg
	ULONG	m_nBufCount ;		// obt@̎coCg
	PBYTE	m_ptrBuffer ;		// ̓obt@̐擪ւ̃|C^
	PBYTE	m_ptrNextBuf ;		// ɓǂݍނׂ̓obt@ւ̃|C^

	struct	ARITHCODE_SYMBOL
	{
		WORD	wOccured ;					// V{̏o
		SWORD	wSymbol ;					// V{
	} ;
	struct	STATISTICAL_MODEL
	{
		DWORD				dwTotalSymbolCount ;	// SV{ < 10000H
		ARITHCODE_SYMBOL	SymbolTable[1] ;		// vf
	} ;
	DWORD	m_dwCodeRegister ;		// R[hWX^
	DWORD	m_dwAugendRegister ;	// I[WFhWX^
	DWORD	m_dwCodeBuffer ;		// rbgobt@
	int		m_nVirtualPostBuf ;		// zobt@JE^
	int		m_nSymbolBitCount ;		// ̃rbg
	int		m_nSymbolSortCount ;	// ̑
	int		m_maskSymbolBit ;		// ̃rbg}XN
	STATISTICAL_MODEL *	m_pLastStatisticalModel ;		// Ō̓vf
	STATISTICAL_MODEL *	m_pStatisticalTable[0x100] ;	// vf

	// MTF e[u
	struct	MTF_TABLE
	{
		BYTE	iplt[0x100] ;

		inline void Initialize( void ) ;
		inline BYTE MoveToFront( int index ) ;
	} ;
	MTF_TABLE *	m_pMTFTable[0x101] ;

	// ֐
	typedef	ULONG (RLHDecodeContext::*PFUNC_DECODE_SYMBOLS)
									( PINT ptrDst, ULONG nCount ) ;
	PFUNC_DECODE_SYMBOLS	m_pfnDecodeSymbols ;

	// nt}
	ERINA_HUFFMAN_TREE *	m_pLastHuffmanTree ;
	ERINA_HUFFMAN_TREE *	m_pHuffmanTree[0x101] ;

public:
	// \z֐
	RLHDecodeContext( ULONG nBufferingSize ) ;
	// Ŋ֐
	virtual ~RLHDecodeContext( void ) ;

	// ̃f[^ǂݍ
	virtual ULONG ReadNextData( PBYTE ptrBuffer, ULONG nBytes ) = 0 ;

	// [tOǂݍŁAReLXg
	void Initialize( void ) ;
	// obt@̎Ãf[^ǂݍ
	int PrefetchBuffer( void ) ;
	// 1rbg擾i 0 ́|1Ԃ j
	INT GetABit( void ) ;
	// nrbg擾
	UINT GetNBits( int n ) ;
	// K}R[h擾
	INT GetACode( void ) ;

	// obt@tbV
	void FlushBuffer( void ) ;
	// Zp̏̕
	void PrepareToDecodeArithmeticCode( int nBitCount ) ;
	// RL-MTF-G ̏̕
	void PrepareToDecodeRLMTFGCode( void ) ;

	// WJf[^擾
	inline ULONG DecodeSymbols( PINT ptrDst, ULONG nCount ) ;
	ULONG DecodeGammaCodes( PINT ptrDst, ULONG nCount ) ;
	ULONG DecodeArithmeticCodes( PINT ptrDst, ULONG nCount ) ;
	ULONG DecodeRLMTFGCodes( PBYTE ptrDst, ULONG nCount ) ;

	// ERINA ̏̕
	void PrepareToDecodeERINACode( void ) ;
	// nt}擾
	int GetAHuffmanCode( ERINA_HUFFMAN_TREE * tree ) ;
	// ̃nt}擾
	int GetLengthHuffman( ERINA_HUFFMAN_TREE * tree ) ;
	// ERINA 𕜍
	ULONG DecodeERINACodes( PINT ptrDst, ULONG nCount ) ;
	// ERINA 𕜍
	ULONG DecodeERINACodesSBZL( SBYTE * ptrDst, ULONG nCount ) ;
	// ERINA i256Fpj𕜍
	ULONG DecodeERINACodes256( PBYTE ptrDst, ULONG nCount ) ;

} ;

//
// MTF_TABLE 
//////////////////////////////////////////////////////////////////////////////
inline void RLHDecodeContext::MTF_TABLE::Initialize( void )
{
	for ( int i = 0; i < 0x100; i ++ )
		iplt[i] = (BYTE) i ;
}

//
// Move To Front s
//////////////////////////////////////////////////////////////////////////////
inline BYTE RLHDecodeContext::MTF_TABLE::MoveToFront( int index )
{
	BYTE	pplt = iplt[index] ;
	while ( index > 0 )
	{
		iplt[index] = iplt[index - 1] ;
		index -- ;
	}
	return	(iplt[0] = pplt) ;
}

//
// WJf[^擾
//////////////////////////////////////////////////////////////////////////////
inline ULONG RLHDecodeContext::DecodeSymbols( PINT ptrDst, ULONG nCount )
{
	return	(this->*m_pfnDecodeSymbols)( ptrDst, nCount ) ;
}


/*****************************************************************************
                               WJIuWFNg
 *****************************************************************************/

class	ERIDecoder
{
protected:
	ERI_INFO_HEADER		m_EriInfHdr ;			// 摜wb_

	UINT				m_nBlockSize ;			// ubLOTCY
	ULONG				m_nBlockArea ;			// ubNʐ
	ULONG				m_nBlockSamples ;		// ubÑTv
	UINT				m_nChannelCount ;		// `l
	ULONG				m_nWidthBlocks ;		// 摜̕iubNj
	ULONG				m_nHeightBlocks ;		// 摜̍iubNj

	UINT				m_nDstBytesPerPixel ;	// 1sNZ̃oCg

	PBYTE				m_ptrOperations ;		// Iy[Ve[u
	PINT				m_ptrColumnBuf ;		// obt@
	PINT				m_ptrLineBuf ;			// sobt@
	PINT				m_ptrBuffer ;			// obt@
	PINT				m_ptrSubBuf ;			// obt@

	INT					m_fEnhancedMode ;		// g[h
	PINT				m_pArrangeTable[4] ;	// TvOe[u

	ERINA_HUFFMAN_TREE *	m_pHuffmanTree ;	// nt}

public:
	typedef	void (ERIDecoder::*PFUNC_COLOR_OPRATION)( void ) ;
	typedef	void (ERIDecoder::*PFUNC_RESTORE)
		( PBYTE ptrDst, LONG nLineBytes, int nWidth, int nHeight ) ;
	struct		OPERATION_CODE_II
	{
		int		ColorOperation ;
		int		ArrangeCode ;
	} ;
	typedef	void (ERIDecoder::*PFUNC_RESTOREII)
		( PBYTE ptrDst, LONG nLineBytes,
			REAL32 * ptrSrc[], int nWidth, int nHeight ) ;
	typedef	void (ERIDecoder::*PFUNC_BLOCK_SCALING)( void ) ;

protected:
	UINT				m_nBlocksetCount ;		// 1ubNZbg̃ubN
	PFUNC_BLOCK_SCALING	m_pfnBlockScaling ;		// ubNXP[O֐

	REAL32 *			m_ptrBuffer2[4][4] ;	// obt@
	REAL32 *			m_ptrBuffer3[16] ;
	REAL32 *			m_ptrBuffer4[16] ;
	REAL32 *			m_ptrWorkDCT1 ;			// DCT ϊpƗ̈
	REAL32 *			m_ptrWorkDCT2 ;
	INT					m_nDCDiffBuffer[16] ;	// DC pobt@

	PINT				m_ptrTableDC ;			// 

	REAL32				m_rMatrixScale ;		// DCT sW
	REAL32				m_rYScaleDC ;			// ̋tʎqW
	REAL32				m_rCScaleDC ;

protected:
	static PFUNC_COLOR_OPRATION	m_pfnColorOperation[0x10] ;
	static const OPERATION_CODE_II	m_opcCodeTable[0x40] ;

public:
	// \z֐
	ERIDecoder( void ) ;
	// Ŋ֐
	virtual ~ERIDecoder( void ) ;

	// ip[^̐ݒj
	int Initialize( const ERI_INFO_HEADER & infhdr ) ;
	// IỉȂǁj
	void Delete( void ) ;
	// 摜WJ
	int DecodeImage
		( const RASTER_IMAGE_INFO & dstimginf,
			RLHDecodeContext & context, bool fTopDown ) ;

protected:
	// TvOe[ȕ
	void InitializeArrangeTable( void ) ;
	void InitializeArrangeTableII( void ) ;
	// tJ[摜̓WJ
	int DecodeTrueColorImage
		( const RASTER_IMAGE_INFO & dstimginf, RLHDecodeContext & context ) ;
	// tJ[摜gtH[}bg̓WJ
	int DecodeTrueColorImageII
		( const RASTER_IMAGE_INFO & dstimginf, RLHDecodeContext & context ) ;
	// pbg摜̓WJ
	int DecodePaletteImage
		( const RASTER_IMAGE_INFO & dstimginf, RLHDecodeContext & context ) ;

	// Iy[Vs
	void PerformOperation
		( DWORD dwOpCode, LONG nAllBlockLines, PINT * ptrNextLineBuf ) ;

	// WJ摜XgA֐ւ̃|C^擾
	virtual PFUNC_RESTORE GetRestoreFunc
		( DWORD fdwFormatType, DWORD dwBitsPerPixel ) ;

	// J[Iy[V֐Q
	void ColorOperation0000( void ) ;
	void ColorOperation0101( void ) ;
	void ColorOperation0110( void ) ;
	void ColorOperation0111( void ) ;
	void ColorOperation1001( void ) ;
	void ColorOperation1010( void ) ;
	void ColorOperation1011( void ) ;
	void ColorOperation1101( void ) ;
	void ColorOperation1110( void ) ;
	void ColorOperation1111( void ) ;

	// OC摜̓WJ
	void RestoreGray8
		( PBYTE ptrDst, LONG nLineBytes, int nWidth, int nHeight ) ;
	// RGB摜(15rbg)̓WJ
	void RestoreRGB16
		( PBYTE ptrDst, LONG nLineBytes, int nWidth, int nHeight ) ;
	// RGB摜̓WJ
	void RestoreRGB24
		( PBYTE ptrDst, LONG nLineBytes, int nWidth, int nHeight ) ;
	// RGBA摜̓WJ
	void RestoreRGBA32
		( PBYTE ptrDst, LONG nLineBytes, int nWidth, int nHeight ) ;

protected:
	// TvOe[ȕ
	void InitializeZigZagTable( void ) ;
	// tJ[摜̈k
	int DecodeTrueColorImageDCT
		( const RASTER_IMAGE_INFO & imginf, RLHDecodeContext & context ) ;

	// WJ摜XgA֐ւ̃|C^擾
	virtual PFUNC_RESTOREII GetRestoreFuncII
		( DWORD fdwFormatType, DWORD dwBitsPerPixel ) ;

	// 𐮐Ɋۂ߂BYTE^ɖOa
	BYTE RoundR32ToByte( REAL32 r ) ;
	// RGB摜̓WJ
	void RestoreRGB24II
		( PBYTE ptrDst, LONG nLineBytes,
			REAL32 * ptrSrc[], int nWidth, int nHeight ) ;
	// RGBA摜̓WJ
	void RestoreRGBA32II
		( PBYTE ptrDst, LONG nLineBytes,
			REAL32 * ptrSrc[], int nWidth, int nHeight ) ;

	// YUV -> RGB ϊ֐
	void ConvertYUVtoRGB( void ) ;

	// 4:4:4 XP[O
	void BlockScaling444( void ) ;
	// 4:2:2 XP[O
	void BlockScaling422( void ) ;
	// 4:1:1 XP[O
	void BlockScaling411( void ) ;

	// IDCT ϊ{
	void PerformIDCT( void ) ;

	// tʎq{
	void ArrangeAndIQuantumize( BYTE bytCoefficient[] ) ;

protected:
	// WJis󋵒ʒm֐
	virtual int OnDecodedBlock( LONG line, LONG column ) ;
	virtual int OnDecodedLine( LONG line ) ;

} ;


/*****************************************************************************
                     t@CXg[ReLXg
 *****************************************************************************/

class	EFileDecodeContext	: public	RLHDecodeContext
{
public:
	// \z֐
	EFileDecodeContext( EFileObject * pFileObj, ULONG nBufferingSize ) ;
	// Ŋ֐
	virtual ~EFileDecodeContext( void ) ;

protected:
	EFileObject *	m_pFileObj ;

public:
	// ̃f[^ǂݍ
	virtual ULONG ReadNextData( PBYTE ptrBuffer, ULONG nBytes ) ;
	// t@CIuWFNgݒ肷
	void AttachFileObject( EFileObject * pFileObj ) ;

} ;


#endif
